//---------------------------------------------------------------
// File: imvwwin.cpp
//
// Member functions of the ImageViewFrame and ImageViewWindow
// classes.
//
//  CompuServe requires the following statement in software that
//  uses the GIF image format:
//
//    "The Graphics Interchange Format(c) is the Copyright
//     property of CompuServe Incorporated. GIF(sm) is a
//     Service Mark property of CompuServe Incorporated."
//
//---------------------------------------------------------------
#include <alloc.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include "imvwwin.h"

#define IDD_THRESHOLD	 101
#define IDD_DAUB         101
#define IDD_INPUTEDITBOX 109
#define IDD_HIST         110
float huge *WorkPlace=NULL;
unsigned char huge *Subtract=NULL;
void Threshold_Level(unsigned char huge *ThresData);
void Window(unsigned char huge *ThresData,int mask_number1, int mask_number2);
void Median(int Mask_Med);
void Thin_Morf(int start_row,int start_col);
void Ridge_Thin();
void Rotate();
void Scaling();
void Equalization();
void do_compression();
void do_uncompression();
void Mean_filter(int Mask_mean);
void fft();
void ifft();
void Forward_daub();
void Compression(long i, long j);
void Inverse_daub();
void Forward_haar();
void Inverse_haar();
void Cubic_Spline();
void Forward_shor();
void Inverse_shor();
void Low_pass_fft();
void Feature();
unsigned char huge *ThresData;
extern unsigned char huge *SepareThresData;
extern BOOL Threscheck;
extern char checkname[80];
extern long number_of_bytes,start_point;
extern int im_width,im_height;
clock_t start,end;
const int MaxThresLevel   = 255;
const int Max_iteration   = 4;
const int MaxStrengthLevel = 10;
int ThresLevel=0;
int StrengthLevel=0;
int Iteration=1;
//---------------------------------------------------------------
// Define the response table for ImageViewFrame
DEFINE_RESPONSE_TABLE1(ImageViewFrame, TMDIClient)
	 EV_WM_QUERYNEWPALETTE,
	 EV_WM_PALETTECHANGED,
	 EV_COMMAND(IDM_ABOUT,     About),
	 EV_COMMAND(IDM_OPENFILE,  OpenFile),
	 EV_COMMAND(IDM_SAVE,      SaveFile),
	 EV_COMMAND(IDM_SAVEAS,    SaveAsFile),
	 EV_COMMAND(IDM_INVERT,    Invert),
	 EV_COMMAND(IDM_THRESHOLD, Thres),
	 EV_COMMAND(IDM_WINDOW16x16, Window16x16),
	 EV_COMMAND(IDM_WINDOW16x8,  Window16x8),
	 EV_COMMAND(IDM_WINDOW8x8,   Window8x8),
	 EV_COMMAND(IDM_WINDOW8x4,   Window8x4),
	 EV_COMMAND(IDM_WINDOW4x4,   Window4x4),
	 EV_COMMAND(IDM_WINDOW4x2,   Window4x2),
	 EV_COMMAND(IDM_THIN_MORF,   Thinning_morf),
	 EV_COMMAND(IDM_THIN_RIDGE,  Thinning_Ridge),
	 EV_COMMAND(IDM_MEDIAN_3x3,  Median_3x3),
	 EV_COMMAND(IDM_MEDIAN_5x5,  Median_5x5),
	 EV_COMMAND(IDM_ROTATION,    Rotation),
	 EV_COMMAND(IDM_SCALE,       Scale),
	 EV_COMMAND(IDM_PIXEL,       Pixel_dir),
	 EV_COMMAND(IDM_BLOCK,       Block_dir),
	 EV_COMMAND(IDM_MAPP,        Mapp),
	 EV_COMMAND(IDM_COMPRESS,    Compress),
	 EV_COMMAND(IDM_UNCOMPRESS,  Uncompress),
	 EV_COMMAND(IDM_HISTEQU,     HistEqu),
	 EV_COMMAND(IDM_MEAN3x3,     Mean3x3),
	 EV_COMMAND(IDM_MEAN5x5,     Mean5x5),
	 EV_COMMAND(IDM_FFT,         Fft),
	 EV_COMMAND(IDM_LOWPASS,     LowPass_Fft),
	 EV_COMMAND(IDM_IFFT,        Ifft),
	 EV_COMMAND(IDM_DAUB_FWWT,   Daub_Fwt),
	 EV_COMMAND(IDM_COMP4,       Comp4_1),
	 EV_COMMAND(IDM_COMP16,      Comp16_1),
	 EV_COMMAND(IDM_COMP26_2,    Comp26_1),
	 EV_COMMAND(IDM_DAUB_IWWT,   Daub_Iwt),
	 EV_COMMAND(IDM_HAAR_FWWT,   Haar_Fwt),
	 EV_COMMAND(IDM_HAAR_IWWT,   Haar_Iwt),
	 EV_COMMAND(IDM_SHOR_FWWT,   Shor_Fwt),
	 EV_COMMAND(IDM_SHOR_IWWT,   Shor_Iwt),
	 EV_COMMAND(IDM_CUBIC,       Cubic_Tr),
	 EV_COMMAND(IDM_PROCESS,     ProcessingTime),
	 EV_COMMAND(IDM_FEATURE,     Feature_ext),
END_RESPONSE_TABLE;
//---------------------------------------------------------------
class TThresDialog : public TDialog {
  public:
	 TThresDialog(TWindow* parent, char far* name)
		  : TWindow(parent), TDialog(parent, name) {}

	 BOOL  CanClose();

	 void  SetupWindow();

	 void  EvHScroll(UINT, UINT, HWND);

  DECLARE_RESPONSE_TABLE(TThresDialog);
};
DEFINE_RESPONSE_TABLE1(TThresDialog, TDialog)
  EV_WM_HSCROLL,
END_RESPONSE_TABLE;

class THistogramDialog : public TDialog {
  public:
	 THistogramDialog(TWindow* parent, char far* name)
		  : TWindow(parent), TDialog(parent, name) {}

	 BOOL  CanClose();

	 void  SetupWindow();

	 void  EvVScroll(UINT, UINT, HWND);

  DECLARE_RESPONSE_TABLE(THistogramDialog);
};
DEFINE_RESPONSE_TABLE1(THistogramDialog, TDialog)
  EV_WM_VSCROLL,
END_RESPONSE_TABLE;

class TDaubDialog : public TDialog {
  public:
	 TDaubDialog(TWindow* parent, char far* name)
		  : TWindow(parent), TDialog(parent, name) {}

	 BOOL  CanClose();

	 void  SetupWindow();

	 void  EvHScroll(UINT, UINT, HWND);

  DECLARE_RESPONSE_TABLE(TDaubDialog);
};
DEFINE_RESPONSE_TABLE1(TDaubDialog, TDialog)
  EV_WM_HSCROLL,
END_RESPONSE_TABLE;

class TThresholdWindow : public TWindow {
  public:
	 TThresholdWindow();
  private:
	 int Level_of_thres;
  friend class TThresDialog;
};
class TDaubWindow : public TWindow {
  public:
	 TDaubWindow();
  private:
	 int number_of_it;
  friend class TDaubDialog;
};
class THistogramWindow : public TWindow {
  public:
	 THistogramWindow();
  private:
	 int Strength_of_hist;
  friend class THistogramDialog;
};

//--------------- TThresDialog ---------------
BOOL
TThresDialog::CanClose()
{
  TThresholdWindow* thresParent = (TThresholdWindow*)Parent; //can cast, no virtual bases

  BOOL noError;
  ThresLevel = GetDlgItemInt(IDD_INPUTEDITBOX, &noError, FALSE);
  if (noError && ThresLevel >= 0 && ThresLevel <256) {
	 thresParent->Level_of_thres = ThresLevel;
	 return TRUE;
  } else {
	 MessageBox("Threshold Level must be a number between 0 and 255! ", "Error", MB_OK);
	 thresParent->Level_of_thres =0;
	 return FALSE;
  }
}

void
TThresDialog::SetupWindow()
{
  TDialog::SetupWindow();
  TThresholdWindow* thresParent = (TThresholdWindow*)Parent; //can cast, no virtual bases

  ::SetScrollRange(GetDlgItem(IDD_THRESHOLD), SB_CTL, 0, MaxThresLevel, FALSE);
  ::SetScrollPos(GetDlgItem(IDD_THRESHOLD), SB_CTL,0, TRUE);
  char str[10];
  ThresLevel=0;
  itoa(thresParent->Level_of_thres , str, 0);
  SetDlgItemText(IDD_INPUTEDITBOX, str);

}

void
TThresDialog::EvHScroll(UINT scrollCode, UINT thumbPos, HWND WndCtrl)
{
  char str[10];
  UINT Pos = ::GetScrollPos(WndCtrl, SB_CTL);
  ThresLevel=Pos;
  itoa(Pos, str, 10);
  SetDlgItemText(IDD_INPUTEDITBOX, str);

  const int PageStep = 10;

  switch (scrollCode) {
  case SB_LINEUP:
	 Pos--;
	 break;
  case SB_LINEDOWN:
	 Pos++;
	 break;
  case SB_PAGEUP:
	 Pos -= PageStep;
	 break;
  case SB_PAGEDOWN:
	 Pos += PageStep;
	 break;
  case SB_THUMBPOSITION:
  case SB_THUMBTRACK:
	 Pos = thumbPos;
	 break;
  }
  ::SetScrollPos(WndCtrl, SB_CTL, Pos, TRUE);
}
BOOL
TDaubDialog::CanClose()
{
  TDaubWindow* DaubParent = (TDaubWindow*)Parent; //can cast, no virtual bases

  BOOL noError;
  Iteration = GetDlgItemInt(IDD_INPUTEDITBOX, &noError, FALSE);
  if (noError && Iteration >= 1 && Iteration <=4) {
	 DaubParent->number_of_it = Iteration;
	 return TRUE;
  } else {
	 MessageBox("Number of iteration must be a number between 1 and 4! ", "Error", MB_OK);
	 DaubParent->number_of_it =1;
	 return FALSE;
  }
}

void
TDaubDialog::SetupWindow()
{
  TDialog::SetupWindow();
  TDaubWindow* DaubParent = (TDaubWindow*)Parent; //can cast, no virtual bases

  ::SetScrollRange(GetDlgItem(IDD_DAUB), SB_CTL, 0, 4, FALSE);
  ::SetScrollPos(GetDlgItem(IDD_DAUB), SB_CTL,0, TRUE);
  char str[10];
  Iteration=1;
  itoa(DaubParent->number_of_it , str, 0);
  SetDlgItemText(IDD_INPUTEDITBOX, str);

}

void
TDaubDialog::EvHScroll(UINT scrollCode, UINT thumbPos, HWND WndCtrl)
{
  char str[10];
  UINT Pos = ::GetScrollPos(WndCtrl, SB_CTL);
  Iteration=Pos;
  itoa(Pos, str, 10);
  SetDlgItemText(IDD_INPUTEDITBOX, str);

  const int PageStep = 1;

  switch (scrollCode) {
  case SB_LINEUP:
	 Pos--;
	 break;
  case SB_LINEDOWN:
	 Pos++;
	 break;
  case SB_PAGEUP:
	 Pos -= PageStep;
	 break;
  case SB_PAGEDOWN:
	 Pos += PageStep;
	 break;
  case SB_THUMBPOSITION:
  case SB_THUMBTRACK:
	 Pos = thumbPos;
	 break;
  }
  ::SetScrollPos(WndCtrl, SB_CTL, Pos, TRUE);
}

BOOL
THistogramDialog::CanClose()
{
  THistogramWindow* histParent = (THistogramWindow*)Parent; //can cast, no virtual bases

  BOOL noError;
  StrengthLevel = GetDlgItemInt(IDD_INPUTEDITBOX, &noError, FALSE);
  if (noError && StrengthLevel >= 0 && StrengthLevel <11) {
	 histParent->Strength_of_hist = StrengthLevel;
	 return TRUE;
  } else {
	 MessageBox("Strength Level must be a number between 1 and 10! ", "Error", MB_OK);
	 histParent->Strength_of_hist =1;
	 return FALSE;
  }
}

void
THistogramDialog::SetupWindow()
{
  TDialog::SetupWindow();
  THistogramWindow* histParent = (THistogramWindow*)Parent; //can cast, no virtual bases

  ::SetScrollRange(GetDlgItem(IDD_HIST), SB_CTL,0, MaxStrengthLevel, FALSE);
  ::SetScrollPos(GetDlgItem(IDD_HIST), SB_CTL,0, TRUE);
  char str[10];
  StrengthLevel=1;
  itoa(histParent->Strength_of_hist , str, 1);
  SetDlgItemText(IDD_INPUTEDITBOX, str);

}

void
THistogramDialog::EvVScroll(UINT scrollCode, UINT thumbPos, HWND WndCtrl)
{
  char str[10];
  UINT Pos = ::GetScrollPos(WndCtrl, SB_CTL);
  StrengthLevel=Pos;
  itoa(Pos, str, 10);
  SetDlgItemText(IDD_INPUTEDITBOX, str);

  const int PageStep = 2;

  switch (scrollCode) {
  case SB_LINEUP:
	 Pos--;
	 break;
  case SB_LINEDOWN:
	 Pos++;
	 break;
  case SB_PAGEUP:
	 Pos -= PageStep;
	 break;
  case SB_PAGEDOWN:
	 Pos += PageStep;
	 break;
  case SB_THUMBPOSITION:
  case SB_THUMBTRACK:
	 Pos = thumbPos;
	 break;
  }
  ::SetScrollPos(WndCtrl, SB_CTL, Pos, TRUE);
}


//---------------------------------------------------------------
// I m a g e V i e w W i n d o w
// Constructor for the ImageViewWindow class
ImageViewWindow::ImageViewWindow(TMDIClient& parent,
	 const char far *title, char far *fname) :
	 TMDIChild(parent, title)
{

	if (Threscheck)
	{

		image=NULL;
		filename = NULL;
		strupr(fname);
		char *ext = strrchr(fname, '.');
		size_t len = strlen(fname);
		filename = new char[len+1];
		strcpy(filename, fname);
		strcpy(checkname,fname);
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
		 if(strcmp(ext, ".BMP") == 0)
		 {
			  image = new BMPImage;
			  image->read(fname);
		 }
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
	 ReleaseCapture();
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
		 if(strcmp(ext, ".PCT") == 0)
		 {
			  image = new BMPImage;
			  image->convert(fname);
		 }
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
	 ReleaseCapture();
	 }
	  else
	 {
		 SetCapture();
		 ::SetCursor(TCursor(NULL, IDC_WAIT));
		  image=NULL;
		  filename=NULL;
		  image = new BMPImage;
		  image->get_thres_image();

		 ::SetCursor(TCursor(NULL, IDC_ARROW));
		 ReleaseCapture();
	 }
	 if(image == NULL)
	 {
	 MessageBox("Unknown image format!",
			  "Fingerprint Recognition System",
						 MB_OK | MB_ICONEXCLAMATION);
	 }
}



//---------------------------------------------------------------
//  ImageViewWindow:: P a i n t
//  Draw image in the window

void ImageViewWindow::Paint(TDC& dc, BOOL,TRect&)
{
	 if(image != NULL)
	 {
		  image->show(dc);
	 }

}

//---------------------------------------------------------------
//  ImageViewFrame:: A b o u t
//  Display the "About..." box

void ImageViewFrame::About()
{
	 TDialog *p_about = new TDialog(this, "ABOUTIMAGEVIEW");
	 GetApplication()->ExecDialog(p_about);
}
//---------------------------------------------------------------
// ImageViewFrame:: O p e n F i l e
// Display file dialog and open requested image file

void ImageViewFrame::OpenFile()
{
	 char name[80] = "*.bmp";
	 char filter[80] = "*.bmp";
	 int status = IDOK;
	 TOpenSaveDialog::TData data;

	 data.FileName = name;
	 data.Filter = filter;
	 data.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST |
					  OFN_PATHMUSTEXIST;

	 strcpy(name, filter);

// Create and display file selection dialog...
	 TFileOpenDialog* p_fd = new TFileOpenDialog(this, data);
	 status = p_fd->Execute();
	 delete p_fd;

 // Load selected image file in a ImageViewWindow
	 if(status == IDOK)
	 {
		  Threscheck=TRUE;
		  ImageViewWindow* iw = new ImageViewWindow(*this, name, name);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
}
//---------------------------------------------------------------
// ImageViewFrame:: E v Q u e r y N e w P a l e t t e
// Realize palette for the currently active child window

BOOL ImageViewFrame::EvQueryNewPalette()
{

	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();

	 if(w == NULL) return 0;
	 HPALETTE hpal = w->current_image()->palette();
	 short changed = 0;
	 if(hpal)
	 {
		  TClientDC dc(w->HWindow);
		  dc.SelectObject(hpal, FALSE);
		  changed = dc.RealizePalette();
		  dc.RestorePalette();
		  if(changed)
		  {
				w->Invalidate(TRUE);
				w->UpdateWindow();
		  }
	 }
	 return changed;
}
//---------------------------------------------------------------
// ImageViewFrame:: E v P a l e t t e C h a n g e d
// Handle a change in system palette

void ImageViewFrame::EvPaletteChanged(HWND hWndPalChg)
{

	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w == NULL) return;

	 if(hWndPalChg == w->HWindow) return;
	 HPALETTE hpal = w->current_image()->palette();
	 short changed = 0;
	 if(hpal)
	 {
		  TClientDC dc(w->HWindow);
		  dc.SelectObject(hpal, FALSE);
		  changed = dc.RealizePalette();
		  if(changed)
		  {
				dc.UpdateColors();
		  }
		  dc.RestorePalette();
	 }
}
//---------------------------------------------------------------
// ImageViewFrame:: S a v e F i l e
// Saves image (being displayed in currently active child window)
// in .BMP format in a file with the same name as the original,
// except for a .BMP extension.

void ImageViewFrame::SaveFile()
{
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL) w->Save();

}
//---------------------------------------------------------------
// ImageViewWindow:: S a v e
// Save image in BMP format

void ImageViewWindow::Save()
{
	 if (filename==NULL) return;
	 char *ext = strrchr(filename, '.');
	 if(strcmp(ext, ".BMP") != 0)
	 {
// Change to an hourglass cursor
		  SetCapture();
		  ::SetCursor(TCursor(NULL, IDC_WAIT));

		  char bmpfilename[128];
		  strcpy(bmpfilename, filename);
		  ext = strrchr(bmpfilename, '.');
		  strcpy(ext, ".BMP");

		  BMPImage ibmp;
		  ibmp.image_data(image);
		  ibmp.write(bmpfilename);

// Reset cursor to arrow
		  ::SetCursor(TCursor(NULL, IDC_ARROW));
		  ReleaseCapture();
	 }
}
//---------------------------------------------------------------
// ImageViewWindow:: S a v e A s F i l e
// Display file dialog and save image in a selected format
// (Nothing happens for now)

void ImageViewFrame::SaveAsFile()
{
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL) w->SaveAsFile();
}
void ImageViewWindow::SaveAsFile()
{

	 char bmpfilename[128];
	 TOpenSaveDialog::TData filenameData(
		  OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY,
		  "Bitmap files (*.bmp)|*.bmp|All files (*.*)|*.*||",
		  0, "", "bmp");
	 if ((new TFileSaveDialog(this,
		 filenameData))->Execute() == IDOK) {
		if (filenameData.Error == 0) { // no error and not cancelled
			string tempName = filename;
			filename = filenameData.FileName;
			strcpy(bmpfilename,filename);
			SetCapture();
		 ::SetCursor(TCursor(NULL, IDC_WAIT));
			BMPImage ibmp;
			ibmp.image_data(image);
			ibmp.write(bmpfilename);
		 ::SetCursor(TCursor(NULL, IDC_ARROW));
			ReleaseCapture();
		}
	 }

}
void ImageViewFrame::Invert()
{

		  SetCapture();
		  ::SetCursor(TCursor(NULL, IDC_WAIT));
		  start=clock();
		  ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
		  if(w != NULL)
		  {
			 w->get_current_image();
			 if (ThresData == 0) ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
			 for(long i=0;i<number_of_bytes;i++) *(ThresData+i)=*(SepareThresData+i);
			 for(long j=start_point;j<number_of_bytes;j++) *(ThresData+j)= abs(255-*(ThresData+j));
			 Threscheck=FALSE;
			 char winname[80];
			 char *name="Invert ";
			 strcpy(winname,name);
			 strcat(winname," of ");
			 strcat(winname,checkname);
			 ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
			 iw->Create();
			 iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		  }
		  end=clock();
		  ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();

}
void ImageViewFrame::Thres()
{
	 char level[10];

	  if (	TThresDialog(this, "ThresOption").Execute()== IDOK )
	  {
		  SetCapture();
		  ::SetCursor(TCursor(NULL, IDC_WAIT));
		  start=clock();
		  ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
		  if(w != NULL)
		  {
			 w->get_current_image();
			 if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
			 for(long i=0;i<number_of_bytes;i++) *(ThresData+i)=*(SepareThresData+i);
			 Threshold_Level(ThresData);
			 Threscheck=FALSE;
			 char winname[80];
			 char *name="Threshold Level ";
			 strcpy(winname,name);
			 itoa(ThresLevel,level,10);
			 strcat(winname,level);
			 strcat(winname," of ");
			 strcat(winname,checkname);
			 ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
			 iw->Create();
			 iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		  }
		  end=clock();
		  ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
	  }


}

void ImageViewFrame::Window16x16()
{
		  start=clock();
		  SetCapture();
		  ::SetCursor(TCursor(NULL, IDC_WAIT));
		  ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
		  if(w != NULL)
		  {
			 w->get_current_image();
			 if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
			 for(long i=0;i<number_of_bytes;i++)
								  *(ThresData+i)=*(SepareThresData+i);
			 Find_Direction(1);
			 Window(ThresData,16,16);
			 Threscheck=FALSE;
			 char winname[80];
			 char *name="16x16 Threshold of ";
			 strcpy(winname,name);
			 strcat(winname,checkname);
			 ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
			 iw->Create();
			 iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		  }
		  end=clock();
		  ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Window16x8()
{
		 SetCapture();
		 ::SetCursor(TCursor(NULL, IDC_WAIT));
		 start=clock();
		 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
		 if(w != NULL)
		 {
			w->get_current_image();
			if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
			for(long i=0;i<number_of_bytes;i++)
							  *(ThresData+i)=*(SepareThresData+i);
			Window(ThresData,16,8);
			Threscheck=FALSE;
			char winname[80];
			char *name="16x8 Threshold of ";
			strcpy(winname,name);
			strcat(winname,checkname);
			ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
			iw->Create();
			iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		 }
		 end=clock();
		 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}

void ImageViewFrame::Window8x8()
{
		  SetCapture();
		  ::SetCursor(TCursor(NULL, IDC_WAIT));
		  start=clock();
		  ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
		  if(w != NULL)
		  {
			  w->get_current_image();
			  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
			  for(long i=0;i<number_of_bytes;i++)
								 *(ThresData+i)=*(SepareThresData+i);
			  Window(ThresData,8,8);
			  Threscheck=FALSE;
			  char winname[80];
			  char *name="8x8 Threshold of ";
			  strcpy(winname,name);
			  strcat(winname,checkname);
			  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
			  iw->Create();
			  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		  }
		  end=clock();
		  ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Window8x4()
{
		 SetCapture();
		 ::SetCursor(TCursor(NULL, IDC_WAIT));
		 start=clock();
		 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
		 if(w != NULL)
		 {
			 w->get_current_image();
			 if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
			 for(long i=0;i<number_of_bytes;i++)
					  *(ThresData+i)=*(SepareThresData+i);
			 Window(ThresData,8,4);
			 Threscheck=FALSE;
			 char winname[80];
			 char *name="8x4 Threshold of ";
			 strcpy(winname,name);
			 strcat(winname,checkname);
			 ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
			 iw->Create();
			 iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		 }
		 end=clock();
		 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Window4x4()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		 w->get_current_image();
		 if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		 for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		 Window(ThresData,32,32);
		 Threscheck=FALSE;
		 char winname[80];
		 char *name="4x4 Threshold of ";
		 strcpy(winname,name);
		 strcat(winname,checkname);
		 ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		 iw->Create();
		 iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Window4x2()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Window(ThresData,4,2);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="4x2 Threshold of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Thinning_morf()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Thin_Morf(0,0);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="With 32x32 Window Thinning of";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Thinning_Ridge()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Ridge_Thin();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="With Ridge Following Thinning of";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Median_3x3()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Median(3);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Median Filtering Using 3x3";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Median_5x5()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Median(5);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Median Filtering Using 5x5";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}


void ImageViewFrame::Rotation()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Rotate();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Rotation of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Scale()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Scaling();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Scaling of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Pixel_dir()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Find_Direction(0);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Pixel wise driectional image of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Block_dir()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Find_Direction(2);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Block directional image of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Mapp()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Find_Direction(3);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Direction mapped of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}


void ImageViewFrame::HistEqu()
{
	  char level[10];
	  if (	THistogramDialog(this, "HistogramDialog").Execute()== IDOK )
	  {
		  SetCapture();
		  ::SetCursor(TCursor(NULL, IDC_WAIT));
		  start=clock();
		  ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
		  if(w != NULL)
		  {
			 w->get_current_image();
			 if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
			 for(long i=0;i<number_of_bytes;i++) *(ThresData+i)=*(SepareThresData+i);
			 Equalization();
			 Threscheck=FALSE;
			 char winname[80];
			 char *name="Equalization Strength";
			 strcpy(winname,name);
			 itoa(StrengthLevel,level,10);
			 strcat(winname,level);
			 strcat(winname," of ");
			 strcat(winname,checkname);
			 ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
			 iw->Create();
			 iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		  }
		  end=clock();
		  ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
	  }


}
void ImageViewFrame::Compress()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  WorkPlace=(float huge*)GlobalAllocPtr(GHND,(long)im_height*(long)im_width*(long)4+1);
		  do_compression();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Compression of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		  iw->make_image(0,im_width/2,im_height/2);

	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}

void ImageViewFrame::Uncompress()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL && WorkPlace!=NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  do_uncompression();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Uncompression of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		  iw->make_image(0,im_width*2,im_height*2);

	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();

}
void ImageViewFrame::Mean3x3()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Mean_filter(3);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Double Window - Trimmed Mean Filter of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Mean5x5()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Mean_filter(5);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Double Window - Trimmed Mean Filter of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}

void ImageViewFrame::Fft()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  fft();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="FFT of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::LowPass_Fft()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Low_pass_fft();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="FFT of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		  //iw->make_image(im_width*4,im_height*2);
		  iw->make_image(0,im_width,im_height);
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}

void ImageViewFrame::Ifft()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  ifft();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Inverse FFT of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Daub_Fwt()
{
	 char level[10];
	 long i;
	 if (	TDaubDialog(this, "DaubDialog").Execute()== IDOK )
	 {
		SetCapture();
		::SetCursor(TCursor(NULL, IDC_WAIT));
		start=clock();
		ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
		if(w != NULL)
		{
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  Subtract=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(i=0;i<number_of_bytes;i++)
				  ThresData[i]=Subtract[i]=SepareThresData[i];

		  WorkPlace=(float huge*)GlobalAllocPtr(GHND,(long)im_height*(long)im_width*(long)4+1);
		  Forward_daub();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Forward Wavelet of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		}
		end=clock();
		::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
	 }


}
void ImageViewFrame::Comp4_1()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL && WorkPlace !=NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Compression(256,256);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Compresssion Ratio is 4:1 ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();

}
void ImageViewFrame::Comp16_1()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL && WorkPlace !=NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Compression(384,384);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Compresssion Ratio is 16:1 ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();

}
void ImageViewFrame::Comp26_1()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL && WorkPlace !=NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Compression(412,412);
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Compresssion Ratio is 26.2:1 ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();

}

void ImageViewFrame::Daub_Iwt()
{
	 long i;
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL && WorkPlace !=NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Inverse_daub();
		  /*for (i=start_point;i<number_of_bytes;i++)
			  ThresData[i]=abs((int)Subtract[i]-(int)ThresData[i]);*/
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Inverse Wavelet of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Haar_Fwt()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Forward_haar();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Inverse Wavelet of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Haar_Iwt()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL && WorkPlace!=NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Inverse_haar();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Inverse Wavelet of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Shor_Fwt()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Forward_shor();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Inverse Wavelet of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Shor_Iwt()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL && WorkPlace!=NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Inverse_shor();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Inverse Wavelet of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Cubic_Tr()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(long i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Cubic_Spline();
		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Cubic Spline Transform of ";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::Feature_ext()
{
	 SetCapture();
	 ::SetCursor(TCursor(NULL, IDC_WAIT));
	 start=clock();
	 ImageViewWindow *w = (ImageViewWindow*)GetActiveMDIChild();
	 long i;
	 if(w != NULL)
	 {
		  w->get_current_image();
		  if (ThresData == 0)  ThresData=(unsigned char huge*)GlobalAllocPtr(GHND, number_of_bytes);
		  for(i=0;i<number_of_bytes;i++)
				  *(ThresData+i)=*(SepareThresData+i);
		  Feature();
		  unsigned char huge *Place=(unsigned char huge*)GlobalAllocPtr(GHND,number_of_bytes);


		  Threscheck=FALSE;
		  char winname[80];
		  char *name="Feature Extraction";
		  strcpy(winname,name);
		  strcat(winname,checkname);
		  ImageViewWindow* iw = new ImageViewWindow(*this,winname,winname);
		  iw->Create();
		  iw->SetIcon(GetApplication(), "IMAGEVIEWWIN_ICON");
		  iw->make_image(0,im_width,im_height);
	 }
	 end=clock();
	 ::SetCursor(TCursor(NULL, IDC_ARROW));
			 ReleaseCapture();
}
void ImageViewFrame::ProcessingTime()
{
	char Buffer[80];
	char *string=(char *)farmalloc(10);
	gcvt((end-start)/CLK_TCK,5,string);
	wsprintf(Buffer,"The Processing Time was %s  second",string);
	MessageBox(Buffer,"Processing Time ",MB_OK);
}
void ImageViewWindow::get_current_image()
{
		 BMPImage ibmp;
		 ibmp.image_data(image);
		 ibmp.get_image();
}
void ImageViewWindow::make_image(int i,int w, int h)
{
	 image=NULL;
	 image = new BMPImage;
	 image->create_image(i,w,h,ThresData);

}


void ImageViewFrame::get_current_image()
{
}



