/***************************************************************************
    Header file for utility programs and macro definitions to be used by
    all programs.
    
    Developed by Jian Lu, jian@ece.ucdavis.edu.
    Last revised 2/28/95.
****************************************************************************/

//#ifndef UTIHDR_INCLUDED
//#define UTIHDR_INCLUDED

/* Useful macros */

#define  PI 3.1415926535897
#define  max(A, B)  ((A) >= (B) ? (A) :  (B))
#define  min(A, B)  ((A) <= (B) ? (A) :  (B))
#define  sign(A)    ((A) >= 0.0 ? 1.0 : -1.0)

/* Useful structures */

typedef struct {
    float mean, var, max, min;
} STAT;			/* Image statistics */

/* Memory and misc utilities */

float huge **fmatrix(long height, long width);
short **smatrix(long height, long width);
float huge ***f3tensor(long height, long width, long depth);
int ***i3tensor(long height, long width, long depth);
STAT imgstat(long m, long n, float **x);
int ipow(int base, int n);

//#endif /* utility header included */
