#include <alloc.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include "imvwwin.h"
#define HL 2
#define GL 10
#define FL 10
#define Gshift 0.5

extern unsigned char huge *ThresData;

extern long number_of_bytes,start_point;
extern int im_width,im_height;

extern float huge *WorkPlace;

extern int Iteration;

float *WaveData=NULL;
float *Workspc=NULL;
int *min_max=(int*) GlobalAllocPtr(GHND,4);
typedef struct {
	int ncof,ioff,joff;
	float *cc,*cr;
} wavefilt;
wavefilt wfilt;
void pwset(int n);
void Scale(float huge *Work,long i,long j);
void Wavelet(int n, int isign);
float huge **fmatrix(long height, long width);
void cswt2d(long m, long n, long nr, float huge *s);
void do_compression()
{
	  long m,i,j,z,ntot=1,i2,i3,nnew,nprev=1;;
	  int i1,k,n,nt;
	  if (WaveData!=NULL) WaveData=NULL;
	  WaveData=(float *) GlobalAllocPtr(GHND,2052);
	  int idim;
	  pwset(4);
	  z=1; n=im_width; nprev=1;
	  for (i=0;i<im_height;i++)
	  {
		 for (j=0;j<im_width;j++)
		 {
			m=start_point+i*im_width+j;
			WorkPlace[z]=(float) *(ThresData+m);
			if ( ((i+j)/2)*2!=(i+j)) WorkPlace[z]=-WorkPlace[z];
			z++;
		 }
	  }
	  ntot=(long)im_height*(long)im_width;
	  for (idim=1;idim<=2;idim++)
	  {
		 nnew=n*nprev;
		 for (i2=0;i2<ntot;i2+=nnew)
		 {
			for(i1=1;i1<=nprev;i1++)
			{
			  for(i3=i1+i2,k=1;k<=n;k++,i3+=nprev) WaveData[k]=WorkPlace[i3];
			  for(nt=n;nt>=4;nt>>=1)  Wavelet(nt,1);
			  for (i3=i1+i2,k=1;k<=n;k++,i3+=nprev) WorkPlace[i3]=WaveData[k];
			}
		 }
		 nprev=nnew;
	  }
	  Scale(WorkPlace,im_height/2,im_width/2);
	  z=0;
	  for (i=im_height/2;i<im_height;i++)
	  {
		 for(j=im_width/2;j<im_width;j++)
		 {
			ThresData[z]=(unsigned char)WorkPlace[i*im_width+j+1];
			z++;
		 }
	  }

	  return;
}
void do_uncompression()
{
	  float TempF;
	  long m,i,j,z,ntot=1,i2,i3,nnew,nprev=1;;
	  int i1,k,n,nt;
	  int idim;
	  z=start_point; n=im_width*2; nprev=1;
	  for (i=0;i<im_height*2;i++)
	  {
		 for (j=0;j<im_width*2;j++)
		 {
			if (i>=im_height && j>=im_width)
			{
			  TempF=(float)(((min_max[1]-min_max[0])* ((float) ThresData[z])+255*min_max[0])/255);
			  WorkPlace[i*im_width*2+j+1]=TempF;
			  z++;
			}
			else WorkPlace[i*im_width*2+j+1]=0.0;
		 }
	  }
	  ntot=(long)im_height*(long)im_width*(long) 4;
	  nprev=1;
	  for (idim=1;idim<=2;idim++)
	  {
		 nnew=n*nprev;
		 for (i2=0;i2<ntot;i2+=nnew)
		 {
			for(i1=1;i1<=nprev;i1++)
			{
			  for(i3=i1+i2,k=1;k<=n;k++,i3+=nprev)WaveData[k]=WorkPlace[i3];
			  for(nt=4;nt<=n;nt<<=1)  Wavelet(nt,-1);
			  for (i3=i1+i2,k=1;k<=n;k++,i3+=nprev) WorkPlace[i3]=WaveData[k];
			}
		 }
		 nprev=nnew;
	  }
	  z=1;
	  for (i=0;i<im_height*2;i++)
	  {
		 for (j=0;j<im_width*2;j++)
		 {
			m=i*im_width*2+j;
			if (WorkPlace[z]<0) WorkPlace[z]=-WorkPlace[z];
			if (WorkPlace[z]>255) WorkPlace[z]=255;
			*(ThresData+m)=(unsigned char) WorkPlace[z];
			z++;
		 }
	  }
	  GlobalFreePtr(WaveData);
	  return;
}

void Forward_daub()
{
	  long m,i,j,z,ntot=1,i2,i3,nnew,nprev=1;
	  int i1,k,n,nt,r,height,width,start;
	  float huge *WorkPlace1=(float huge*)GlobalAllocPtr(GHND,(long)im_height*(long)im_width*(long)4+1);
	  int idim;
	  if (WaveData!=NULL) WaveData=NULL;
	  WaveData=(float *) GlobalAllocPtr(GHND,512*4+4);
	  pwset(20);
	  z=1;
	  for (i=0;i<im_height;i++)
	  {
		 for (j=0;j<im_width;j++)
		 {
			m=start_point+i*im_width+j;
			WorkPlace[z]=(float) *(ThresData+m);
			if ( ((i+j)/2)*2!=(i+j)) WorkPlace[z]=-WorkPlace[z];
			WorkPlace1[z]=WorkPlace[z];
			z++;
		 }
	  }
	height=im_height;width=im_width;
	for (r=1;r<=Iteration;r++)
	{
	  n=width; nprev=1;

	  ntot=(long)height*(long)width;
	  for (idim=1;idim<=2;idim++)
	  {
		 nnew=n*nprev;
		 for (i2=0;i2<ntot;i2+=nnew)
		 {
			for(i1=1;i1<=nprev;i1++)
			{
			  for(i3=i1+i2,k=1;k<=n;k++,i3+=nprev) WaveData[k]=WorkPlace1[i3];
			  for(nt=n;nt>=4;nt>>=1)
			  {
				  Wavelet(nt,1);
			  }
			  for (i3=i1+i2,k=1;k<=n;k++,i3+=nprev) WorkPlace1[i3]=WaveData[k];
			}
		 }
		 nprev=nnew;
	  }
	  start=im_width-width;
	  m=1;
	  for (i=start;i<512;i++)
	  {
		 for (j=start;j<512;j++)
		 {
			 z=i*(long)im_width+j+1;
			 WorkPlace[z]=WorkPlace1[m];
			 m++;
		 }
	  }

	  width=width/2;height=height/2;
	  z=1;
	  for (i=im_height-height;i<im_height;i++)
	  {
		 for (j=im_width-width;j<im_width;j++)
		 {
			WorkPlace1[z]=WorkPlace[i*(long)im_width+j+1];
			if ( ((i+j)/2)*2!=(i+j)) WorkPlace1[z]=-WorkPlace1[z];
			z++;
		 }
	  }


	}

	  Scale(WorkPlace,im_height-height,im_width-width);


	  for (i=0;i<im_height;i++)
	  {
		 for(j=0;j<im_width;j++)
		 {
			z=i*(long)im_width+j;
			ThresData[start_point+z]=(unsigned char)(fabs(WorkPlace[z+1]));
		 }
	  }
	  GlobalFreePtr(WorkPlace1);
	  GlobalFreePtr(WaveData);
	  return;
}
void Compression(long i, long j)
{
	  long k,l,z;
	  for (k=0;k<im_height;k++)
	  {

		for (l=0;l<im_width;l++)
		{
			if (k<i || l<j)
			{
				z=k*(long)im_width+l+1;
				WorkPlace[z]=0;
			}
		}

	  }
	  for (k=0;k<im_height;k++)
	  {
		 for(l=0;l<im_width;l++)
		 {
			z=k*(long)im_width+l;
			ThresData[start_point+z]=(unsigned char)(fabs(WorkPlace[z+1]));
		 }
	  }
	  return;
}

void Inverse_daub()
{
	  float TempF;
	  long m,i,j,z,ntot=1,i2,i3,nnew,nprev=1;
	  int i1,k,n,nt,width;
	  int idim,r;
	  WaveData=(float *) GlobalAllocPtr(GHND,512*4+4);
	  float huge *WorkPlace1=(float huge*)GlobalAllocPtr(GHND,(long)im_height*(long)im_width*(long)4+4);
	  width=im_width/(pow((double)2,(double)Iteration));
	  for (i=im_height-width;i<im_height;i++)
	  {
		 for (j=im_width-width;j<im_width;j++)
		 {

			  TempF=(float)(((min_max[1]-min_max[0])*WorkPlace[i*im_width+j+1] +255*min_max[0])/255);
			  WorkPlace[i*im_width+j+1]=TempF;
		 }
	  }

	for(r=1;r<=Iteration;r++)
	{
	  width=width*2;
	  z=1;
	  for (i=im_height-width;i<im_height;i++)
	  {
		 for (j=im_width-width;j<im_width;j++)
		 {
			  WorkPlace1[z]=WorkPlace[i*(long)im_width+j+1];
			  z++;
		 }
	  }
	  n=width; nprev=1;
	  ntot=(long)n*(long)n;
	  nprev=1;
	  for (idim=1;idim<=2;idim++)
	  {
		 nnew=n*nprev;
		 for (i2=0;i2<ntot;i2+=nnew)
		 {
			for(i1=1;i1<=nprev;i1++)
			{
			  for(i3=i1+i2,k=1;k<=n;k++,i3+=nprev) WaveData[k]=WorkPlace1[i3];
			  for(nt=4;nt<=n;nt<<=1)  Wavelet(nt,-1);
			  for (i3=i1+i2,k=1;k<=n;k++,i3+=nprev) WorkPlace1[i3]=WaveData[k];
			}
		 }
		 nprev=nnew;
	  }

	  z=1;
	  for (i=im_height-width;i<im_height;i++)
	  {
		 for (j=im_width-width;j<im_width;j++)
		 {
			  if ( ((i+j)/2)*2!=(i+j)) WorkPlace1[z]=-WorkPlace1[z];
			  WorkPlace[i*(long)im_width+j+1]=WorkPlace1[z];
			  z++;
		 }
	  }
	}
	  //Scale(WorkPlace,im_height-width,im_width-width);
	  z=1;
	  for (i=0;i<im_height;i++)
	  {
		 for (j=0;j<im_width;j++)
		 {
			m=start_point+i*im_width+j;
			if (WorkPlace[z]<0) WorkPlace[z]=-WorkPlace[z];
			if (WorkPlace[z]>255)
				 WorkPlace[z]=255;
			*(ThresData+m)=(unsigned char) WorkPlace[z];
			z++;
		 }
	  }

	  GlobalFreePtr(WaveData);
	  return;

}
void Forward_haar()
{
	long z;
	z = (long) 512 * (long) 512 * (long) 2;
	int huge *buf1=(int huge *) GlobalAllocPtr(GHND,z);
	int huge *buf2=(int huge *) GlobalAllocPtr(GHND,z);
	int huge *buf=(int huge *) GlobalAllocPtr(GHND,z);
	WorkPlace = (float huge *) GlobalAllocPtr(GHND,z*2);
	long i,j;
	for (i=0;i<512;i++)
	{
	  for (j=0;j<512;j++)
	  {
		 WorkPlace[i*512+j]=(int) ThresData[start_point+i*512+j];
	  }
	}
	for (i=0;i<512;i++)
	{
	  for (j=0;j<512;j+=2)
	  {
		  z=i*512+j;
		  buf1[i*512+j/2]=(int)(WorkPlace[i*512+j]+WorkPlace[i*512+j+1])/2;
	  }
	}

	for (i=0;i<512;i++)
	{
	  for(j=0;j<512;j++)
	  {
		 buf2[i*512+j]=buf1[j*512+i];
	  }
	}
	for (i=0;i<512;i++)
	{
	  for (j=0;j<512;j+=2)
	  {
		  z=i*512+j;
		  buf[i*512+j/2]=(buf2[i*512+j]+buf2[i*512+j+1])/2;
	  }
	}
	for (i=0;i<512;i++)
	{
	  for (j=0;j<512;j++)
	  {
		  ThresData[start_point+i*512+j]=(unsigned char) buf[j*512+i];
		  WorkPlace[i*512+j]=(float) buf[j*512+i];
	  }
	}
}
void Inverse_haar()
{
	long z;
	z = (long) 512 * (long) 512 * (long) 4;
	float huge *Buf=(float huge *) GlobalAllocPtr(GHND,z);
	long i,j;
	for (i=0;i<256;i++)
	{
	  for (j=0;j<256;j++)
	  {

		 Buf[i*2*512+j*2]= (WorkPlace[i*512+j] +( WorkPlace[(i+256)*512+j] +
			  WorkPlace[i*512+j+256] + WorkPlace[(i+256)*512+j+256]) /2);

		 Buf[(i*2+1)*512+j*2]=( WorkPlace[i*512+j] +(- WorkPlace[(i+256)*512+j] +
			  WorkPlace[i*512+j+256] -  WorkPlace[(i+256)*512+j+256]) /2);

		 Buf[i*2*512+j*2+1]=(WorkPlace[i*512+j] +(WorkPlace[(i+256)*512+j] -
			  WorkPlace[i*512+j+256] -  WorkPlace[(i+256)*512+j+256]) /2);

		 Buf[(i*2+1)*512+j*2+1]=  (WorkPlace[i*512+j] +(-WorkPlace[(i+256)*512+j] -
			  WorkPlace[i*512+j+256] +  WorkPlace[(i+256)*512+j+256]) /2);

	  }
	}
	for (i=0;i<512;i++)
	{
	  for (j=0;j<512;j++)
	  {
		 z=start_point+i*512+j;
		 ThresData[z]=(unsigned char) Buf[i*512+j];
	  }
	}

}
void Forward_shor()
{
	long z;
	z = (long) 512 * (long) 512 * (long) 4;
	WorkPlace=(float *) GlobalAllocPtr(GHND,z);
	long i,j;
	for (i=0;i<256;i++)
	{
	  for (j=0;j<256;j++)
	  {

		 WorkPlace[i*512+j]=( (float) ThresData[start_point+i*2*512+j*2] + (float) ThresData[start_point+(i*2+1)*512+j*2] +
			 (float) ThresData[start_point+i*2*512+j*2+1] + (float) ThresData[start_point+(i*2+1)*512+j*2+1]) /4;

		 WorkPlace[(i+256)*512+j]=( (float) ThresData[start_point+i*2*512+j*2] - (float) ThresData[start_point+(i*2+1)*512+j*2] +
			 (float) ThresData[start_point+i*2*512+j*2+1] - (float) ThresData[start_point+(i*2+1)*512+j*2+1]) /2;

		 WorkPlace[i*512+256+j]=( (float) ThresData[start_point+i*2*512+j*2] + (float) ThresData[start_point+(i*2+1)*512+j*2] -
			 (float) ThresData[start_point+i*2*512+j*2+1] - (float) ThresData[start_point+(i*2+1)*512+j*2+1]) /2;

		 WorkPlace[(i+256)*512+256+j]=( (float) ThresData[start_point+i*2*512+j*2] - (float) ThresData[start_point+(i*2+1)*512+j*2] -
			 (float) ThresData[start_point+i*2*512+j*2+1] + (float) ThresData[start_point+(i*2+1)*512+j*2+1]) /2;

	  }
	}
/*	for (i=0;i<256;i++)
	{
	  for (j=256;j<512;j++)
	  {
		 if (WorkPlace[i*512+j-256] >128.0) WorkPlace[i*512+j]=255.0;
		 else WorkPlace[i*512+j]=0.0;
	  }
	}*/
/*	for (i=256;i<512;i++)
	{
	  for (j=0;j<256;j++)
	  {
		 if (WorkPlace[(i-256)*512+j]>128.0) WorkPlace[i*512+j]=255.0;
		 else WorkPlace[i*512+j]=0.0;
	  }
	}*/
/*	for (i=256;i<512;i++)
	{
	  for (j=256;j<512;j++)
	  {
		 if (WorkPlace[(i-256)*512+j-256]>128.0) WorkPlace[i*512+j]=255.0;
		 else WorkPlace[i*512+j]=0.0;
	  }
	}   */

	for (i=0;i<512;i++)
	{
	  for (j=0;j<512;j++)
	  {
		 z=start_point+i*512+j;
		 ThresData[z]=(unsigned char) WorkPlace[i*512+j];

	  }
	}

}
void Inverse_shor()
{
	long z;
	z = (long) 512 * (long) 512 * (long) 4;
	float huge *Buf=(float huge *) GlobalAllocPtr(GHND,z);
	long i,j;
	for (i=0;i<256;i++)
	{
	  for (j=0;j<256;j++)
	  {

		 Buf[i*2*512+j*2]= (WorkPlace[i*512+j] +( WorkPlace[(i+256)*512+j] +
			  WorkPlace[i*512+j+256] + WorkPlace[(i+256)*512+j+256]) /2);

		 Buf[(i*2+1)*512+j*2]=( WorkPlace[i*512+j] +(- WorkPlace[(i+256)*512+j] +
			  WorkPlace[i*512+j+256] -  WorkPlace[(i+256)*512+j+256]) /2);

		 Buf[i*2*512+j*2+1]=(WorkPlace[i*512+j] +(WorkPlace[(i+256)*512+j] -
			  WorkPlace[i*512+j+256] -  WorkPlace[(i+256)*512+j+256]) /2);

		 Buf[(i*2+1)*512+j*2+1]=  (WorkPlace[i*512+j] +(-WorkPlace[(i+256)*512+j] -
			  WorkPlace[i*512+j+256] +  WorkPlace[(i+256)*512+j+256]) /2);

	  }
	}
	for (i=0;i<512;i++)
	{
	  for (j=0;j<512;j++)
	  {
		 z=start_point+i*512+j;
		 ThresData[z]=(unsigned char) Buf[i*512+j];
	  }

	}

}
void Wavelet(int n, int isign)
{
	 int nmod,n1,nh;
	 int i,ii,jf,jr,k,ni,nj;
	 float ai,ai1;
	 Workspc=(float*)GlobalAllocPtr(GHND,n*4+4);

	 nmod=n*12;
	 n1=n-1;
	 nh=n>>1;

	 if (isign == 1)
	 {
		for (ii=1,i=1;i<=n;i+=2,ii++)
		{
		  ni=i+nmod+wfilt.ioff;
		  nj=i+nmod+wfilt.joff;
		  for (k=1;k<=wfilt.ncof;k++)
		  {
			 jf=n1 & (ni+k);
			 jr=n1 & (nj+k);

			 Workspc[ii]+=wfilt.cc[k]*WaveData[jf+1];
			 Workspc[ii+nh]+=wfilt.cr[k]*WaveData[jr+1];

		  }
		}
	 }
	 else
	 {
		for (ii=1,i=1;i<=n;i+=2,ii++)
		{
		  ai=WaveData[ii];
		  ai1=WaveData[ii+nh];
		  ni=i+nmod+wfilt.ioff;
		  nj=i+nmod+wfilt.joff;
		  for (k=1;k<=wfilt.ncof;k++)
		  {
			 jf=(n1 & (ni+k))+1;
			 jr=(n1 & (nj+k))+1;

			 Workspc[jf]+=wfilt.cc[k]*ai;
			 Workspc[jr]+=wfilt.cr[k]*ai1;
		  }
		}
	 }

	 for (i=1;i<=n;i++) WaveData[i]=Workspc[i];
	 GlobalFreePtr(Workspc);

	 return;
}
void Scale(float huge *Work,long i, long j)
{
	long i1,j1,u;
	float scale=0;
	int TempI;
	int min,max;
	min=max=(int)Work[i*(long)im_width+j+1];
	  for (i1=i;i1<im_height;i1++)
	  {
		 for(j1=j;j1<im_width;j1++)
		 {
			  TempI=(int) (Work[i1*im_width+j1+1]+.5);
			  Work[i1*im_width+j1+1]=(float) TempI;
			  if (min>abs(TempI)) min=TempI;
			  if (max<abs(TempI)) max=TempI;
		 }
	  }
	  min_max[0]=min;min_max[1]=max;


	if (min==max) scale=1.0;
	else scale=max-min;

	for (i1=i;i1<im_height;i1++)
	{
	  for(j1=j;j1<im_width;j1++)
	  {
			u=i1*im_width+j1+1;
			Work[u]=(fabs(Work[u])-(float)min)*255/scale;
	  }
	}

	return;
}
void Cubic_Spline()
{
	 long i,j,z;
	 z = (long) 512 * (long) 512 * (long) 4;
	 WorkPlace=(float *) GlobalAllocPtr(GHND,z);
	 for (i=0;i<512;i++)
	 {
		for (j=0;j<512;j++)
		{
		  WorkPlace[i*im_width+j]=(float) ThresData[start_point+i*im_width+j];

		}
	 }
	 cswt2d(512,512,1,WorkPlace);
	 for (i=0;i<512;i++)
	 {
		for (j=0;j<512;j++)
		{
		  ThresData[start_point+i*512+j]=(unsigned char) WorkPlace[i*512+j];
		}
	 }

	 return;

}
void cswt2d(long m, long n, long nr, float huge *s)
{
	 int index(int i, long n);

	 static float h[HL+1]= {0.375, 0.25, 0.0625};

	 int i,j;
	 int k,ii,jj,l,js[4];
	 float huge **ws=fmatrix(m,n);

/* Start wavelet decomposition with row convolutions */
	 for (k=0; k<nr; k++)
	 {
		for (i=0; i<m; i++)
		{
		  for (j=0; j<n; j++)
		  {
			 ws[i][j] = h[0]*s[i*512+(j%n)];
			 for(jj=1; jj<=HL; jj++)
			 {
				 /* adjusting indices*/
				 js[0] = j - (int)Gshift - jj+1;
				 js[1] = j - (int)Gshift + jj;
				 js[2] = j - jj;
				 js[3] = j + jj;
				 for(l=0; l<4; l++) js[l] = index(js[l],n);
						  /* Computing WT coefficients*/
				 ws[i][j] += h[jj]*(s[i*512+js[2]]+s[i*512+js[3]]);

			 }
		  }
		}
				/* Column convolutions now */
		for (j=0; j<n; j++)
		{
			for (i=0; i<m; i++)
			{
				s[i*512+j] = h[0]*ws[(i%m)][j];

				for(ii=1; ii<=HL; ii++)
				{
						  /* adjusting indices */
					 js[0] = i - (int)Gshift - ii+1;
					 js[1] = i - (int)Gshift + ii;
					 js[2] = i - ii;
					 js[3] = i + ii;
					 for(l=0; l<4; l++) js[l] = index(js[l],m);
						  /* Computing WT coefficients */
					 s[i*512+j] += h[ii]*(ws[js[2]][j]+ws[js[3]][j]);

				}
			}
		}
	 }
	 GlobalFreePtr(ws);
	 return;
}
float huge **fmatrix(long height, long width)
/*  Allocate a float matrix */
{
	 int i;
	 float huge **m;
	 long y;
	 y=height*(long)sizeof(float *);
	 m = (float huge **)GlobalAllocPtr(GHND,y);
	 y=width*height*(long) sizeof(float);
	 m[0] = (float huge *)GlobalAllocPtr(GHND,y);

	 for (i=1; i<height; i++) m[i]=m[i-1]+width;
	 return (m);
}

int index(int i, long n)
{
/* Adjusting indecies of data array using Mallat's symmetry assumption
*/
	 i = i%(2*n-2);
	 if(i<0){
		  if(i<(1-n))
				i = i+2*n-2;
		  else
				i = -i;
	 }
	 else if(i>(n-1)) i = 2*n-2-i;
	 return (i);
}

void pwset(int n)
{
	int k;
	float sig=-1.0;
	static float c2[3]={0, 0.7071067811866, 0.7071067811866};
	static float c4[5]={0,0.4829629131445341, 0.8365163037378079,
								 0.2241438680420134,-0.1294095225512604};
	static float c6[7]={0,.3327,.8069,.4599,-.1350,-.0854,.0352};
	static float c12[13]={0.0, 0.111540743350, 0.494623890398, 0.7511333908021,
		 0.315250351709,-0.226264693965, -0.129766867567,
		 0.097501605587,0.027522865530,-0.031582039318,
		 0.000553842201,0.00477257511,-0.001077301085};
	static float c20[21]={0.0,0.026670057901,0.188176800078,0.527201188932,
			  0.688459039454,0.281172343661,-0.249846424327,
			 -0.195946274377, 0.127369340336,0.093057364604,
			 -0.071394147166,-0.029457536822,0.033212674059,
			  0.003606553567,-0.010733175483,0.001395351747,
			  0.001992405295,-0.000685856695,-0.000116466855,
			  0.000093588670,-0.000013264203};
	static float c2r[3],c4r[5],c6r[7],c12r[13],c20r[21];
	wfilt.ncof=n;
	if (n==2)
	{
	  wfilt.cc=c2;
	  wfilt.cr=c2r;
	}
	if (n==4)
	{
	  wfilt.cc=c4;
	  wfilt.cr=c4r;
	}
	if (n==6)
	{
	  wfilt.cc=c6;
	  wfilt.cr=c6r;
	}
	if (n==12)
	{
	  wfilt.cc=c12;
	  wfilt.cr=c12r;
	}
	if (n==20)
	{
	  wfilt.cc=c20;
	  wfilt.cr=c20r;
	}
	for (k=1;k<=n;k++)
	{
	  wfilt.cr[wfilt.ncof+1-k]=sig*wfilt.cc[k];
	  sig=-sig;
	}
	wfilt.ioff=wfilt.joff=-(n>>1);
}
